/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : rtb_adapter
Version : 1.4
Date    : 09.07.2012
Author  : KoledaS                            
Company :  
Comments: koledas@rambler.ru


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/        

#include <mega8.h>

eeprom unsigned int data_eeprom[8]={0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF};

// 
interrupt [ADC_INT] void adc_isr(void) {
unsigned int i;
unsigned char ind;

if(!(PINB.7)){ //   
  i=0;
  ind=~PIND;
  while(ind >>= 1) ++i; //    mp3-
  if(PIND!=0xFF) data_eeprom[i] = ADCW; //      mp3-  
}
else{ //   
  ind=1; //    
  for (i=0;i<8;i++){ //   
    //         (+/-3 )
    if((ADCW<(data_eeprom[i]+3)) && (ADCW>(data_eeprom[i]-3))){
      DDRD|=(0x01<<i); //        mp3-    
      ind=0; //      
    }
  }
  if(ind){ //   
    DDRD=0x00; //       Z-
  }
}

ADCSRA|=0b01000000;
}//end adc_isr

void main(void) {
//
DDRB=0b00;  //  B  
PORTB=0xFF; //  

ADCSRA=0b11001110;
#asm("sei")
ADMUX=0;
ADCSRA|=0b01000000;

// 
while (1)
{
  DDRD=0x00;  //  D  
  PORTD=0x00; // Z-
  while(PINB.7);
  DDRD=0x00;  //  D  
  PORTD=0xFF; //  
  while(!(PINB.7));
}

}//end main